--|-----------------------------------------------------------------
--|-- G"unther K"ogel
--|-- University of Stuttgart
--|-----------------------------------------------------------------
-- parser skeletton used by lalr

indexing
	date: "Mon Feb  1 18:00:26 MET 1993";
	revision: "1.4"

-- 1.4 time consistency check between yyParserEiffelTextFile and
--     yyParserEiffelObjectFile
-- 1.3 debug output depends now on yydebugParser
-- 1.2 changed loop in ErrorRecovery: sets have MaxSize + 1 elements
-- 1.1 debug information and token names inserted
-- 1.0 initial revision

$@ class @
export
$E
Parser, CloseParser
inherit exceptions rename comment as exceptions_comment

feature

yyo		: FILE;			-- output during debug
yydebugParser	: BOOLEAN;

$G	-- GLOBAL section is inserted here

-- CONST
   yyInitStackSize	: INTEGER IS 100;
   yyNoState		: INTEGER IS 0;

$T	-- Table Constants are inserted here

-- TYPE
  yyTBase		: LSARRAY [INTEGER]; -- 0..yyLastReadState
  yyNBase		: LSARRAY [INTEGER]; -- 0..yyLastReadState
  yyDefault		: LSARRAY [INTEGER]; -- ARRAY [0..yyLastReadState] OF yyReadRange;
  yyTComb		: LSARRAY [STATECONTROL]; -- ARRAY yyTCombRange	OF yyTCombType;
  yyNComb		: LSARRAY [INTEGER]; -- ARRAY yyNCombRange  OF yyNCombType;
  yyLength		: LSARRAY [INTEGER]; -- ARRAY yyReduceRange OF yyTableElmt;
  yyLeftHandSide	: LSARRAY [INTEGER]; -- ARRAY yyReduceRange OF yySymbolRange;
  yyContinuation	: LSARRAY [INTEGER]; -- ARRAY [0..yyLastReadState] OF yySymbolRange;
  yyFinalToProd		: LSARRAY [INTEGER]; -- ARRAY yyReadReduceRange OF yyReduceRange;
  yyIsInitialized	: BOOLEAN;
  yyStateStackSize	: INTEGER;
  xxMaxToken		: INTEGER;
  yyParserEiffelObjectFile	: STRING;	-- eiffel object file
  yyParserEiffelTextFile	: STRING;	-- ascii representation
  Errors		: errors;
$@   Scanner		: $;

Create is
  do
    yyIsInitialized := FALSE;
    xxMaxToken := yyLastTerminal;
    yyParserEiffelObjectFile.Create (32);
$@     yyParserEiffelObjectFile.Append ("@.eof");
    yyParserEiffelTextFile.Create (32);
$@     yyParserEiffelTextFile.Append ("@.txt");

    Errors.Create;
    Scanner.Create;
    
    yyTBase.Create (0, -1);
    yyNBase.Create (0, -1);
    yyDefault.Create (0, -1);
    yyTComb.Create (0, -1);
    yyNComb.Create (0, -1);
    yyLength.Create (0, -1);
    yyLeftHandSide.Create (0, -1);
    yyContinuation.Create (0, -1);
    yyFinalToProd.Create (0, -1);

    debug
      if yydebugParser then
        yyo := io.error;
      end;
    end;
  end; -- Create

xxTokenName (index: INTEGER): STRING is
  do
    RESULT.Create (31);
    inspect index
$W	-- token names are inserted here
    else
      RESULT.Append ("unkown index");
    end; -- inspect
  end; -- xxTokenName

Parser: INTEGER is
  local
--  VAR
    yyState		: INTEGER;		-- yyStateRange;
    yyTerminal		: INTEGER;  		-- yySymbolRange;
    yyNonterminal	: INTEGER;		-- yySymbolRange; -- left-hand side symbol
    yyStackPtr		: INTEGER;		-- yyTableElmt;
    yyShortStackSize	: INTEGER;		-- yyTableElmt;
    yyStateStack	: ARRAY [INTEGER];  	-- yyStackType;
    yyAttrStackSize	: INTEGER;		-- yyTableElmt;
    yyAttributeStack	: ARRAY [ATTRIBUTE];	-- POINTER TO ARRAY [0..1000000] OF tParsAttribute;
    yySynAttribute	: ATTRIBUTE;          	-- tParsAttribute -- synthesized attribute
    yyRepairAttribute	: SCANATTRIBUTE;	-- Scanner.tScanAttribute;
    yyRepairToken	: INTEGER;		-- yySymbolRange;
    yyIsRepairing	: BOOLEAN;
    yyErrorCount	: INTEGER;		-- CARDINAL;
    yyTCombIndex	,			-- new
    yyNCombIndex	: INTEGER;
    yyquit		,
    yyquit_loop2	,
    yyquit_loop3	: BOOLEAN;
$L	 LOCAL section is inserted here
  do
    BeginParser;
    yyState		:= yyStartState;
    yyTerminal		:= Scanner.GetToken;
    yyStateStackSize	:= yyInitStackSize;
    yyAttrStackSize	:= yyInitStackSize;
    yyStateStack.Create (0, yyStateStackSize);
    yyAttributeStack.Create (0, yyAttrStackSize);
    yyShortStackSize	:= yyStateStackSize - 1;
    yyStackPtr		:= 0;
    yySynAttribute.Create;
    yyErrorCount	:= 0;
    yyIsRepairing	:= FALSE;

    from until yyquit loop -- loop 1
      if yyStackPtr >= yyShortStackSize then
        yyStateStackSize := 2 * yyStateStackSize;
        yyStateStack.resize (0, yyStateStackSize);
        yyAttrStackSize := 2 * yyAttrStackSize;
        yyAttributeStack.resize (0, yyAttrStackSize);
        yyShortStackSize := yyStateStackSize - 1;
      end;

      yyStateStack.put (yyState, yyStackPtr);

			-- SPEC State := Next (State, yyTerminal); terminal transition
      from yyquit_loop2 := FALSE
      until yyquit_loop2 loop
        yyTCombIndex := yyTBase.item (yyState) + yyTerminal;
        if yyTComb.item (yyTCombIndex).CheckState = yyState then
          yyState := yyTComb.item (yyTCombIndex).NextState;

	  debug
	    if yydebugParser then
	      yyo.putstring ("\nnew state:");
	      yyo.putint (yystate);
	    end;
	  end;

          yyquit_loop2 := TRUE;				-- EXIT
	else
          yyState := yyDefault.item (yyState);

          debug
            if yydebugParser then
              yyo.putstring("\ndefault state is: ");
              yyo.putint (yystate);
              yyo.putchar(' ');
            end;
          end;

          if yyState = yyNoState then			-- syntax error
            yyState := yyStateStack.item (yyStackPtr);
            if yyIsRepairing then			-- repair
              yyRepairToken := yyContinuation.item (yyState);
              yyState := Next (yyState, yyRepairToken);
              if yyState <= yyLastReadReduceState then	-- read or read reduce ?
                yyRepairAttribute := Scanner.ErrorAttribute (yyRepairToken);
                Errors.ErrorMessageI (Errors.TokenInserted, Errors.Repair, yyRepairAttribute.Line,
		  yyRepairAttribute.Column, Errors.IsString, xxTokenName (yyRepairToken));
                if yyState >= yyFirstReadReduceState then	-- avoid second push
                  yyState := yyFinalToProd.item (yyState);
                end;
                yyStackPtr := yyStackPtr + 1;
                yyAttributeStack.put (yyRepairAttribute, yyStackPtr);
                yyStateStack.put (yyState, yyStackPtr);
              end;
              if yyState >= yyFirstReadReduceState then	-- final state ?
                yyquit_loop2 := TRUE;			-- EXIT
              end;
            else					-- report and recover
              yyErrorCount := yyErrorCount + 1;
              yyTerminal := ErrorRecovery (yyTerminal, yyStateStack, yyStateStackSize, yyStackPtr);
              yyIsRepairing := TRUE;
            end;
          end;
        end;
      end; -- loop 2

      if yyState >= yyFirstReadReduceState then		-- final state ?
	if yyState <= yyLastReadReduceState then	-- read reduce ?
	  yyStackPtr := yyStackPtr + 1;
	  yyAttributeStack.put (Scanner.Attribute, yyStackPtr);
	  yyTerminal := Scanner.GetToken;
	  yyIsRepairing := FALSE;
$X	  yyState := yyFinalToProd.item (yyState);
	end;

	from yyquit_loop3 := FALSE
	until yyquit_loop3 LOOP -- loop 3		-- reduce
	  debug
	    if yydebugParser then
	      yyo.putstring("\n select production #:");
	      yyo.putint (yyState);
	    end;
	  end;

$R	-- Code for Reductions is inserted here
		 -- SPEC State := Next (Top (), Nonterminal); nonterminal transition
	  if not yyquit then
	    yyNCombIndex := yyNBase.item (yyStateStack.item (yyStackPtr)) + yyNonterminal;
	    yyState := yyNComb.item (yyNCombIndex);
	    yyStackPtr := yyStackPtr + 1;
	    yyAttributeStack.put (yySynAttribute, yyStackPtr);

	    debug
	      if yydebugParser then
		yyo.putstring ("\nnew state after production:");
		yyo.putint (yyState);
	      end;
	    end;

	    if yyState < yyFirstReadReduceState then	-- read nonterminal ?
	      yyquit_loop3 := TRUE;			-- EXIT
	    else
$X            yyState := yyFinalToProd.item (yyState);
	    end; -- if
	  end;
	end;

      else						-- read
	yyStackPtr := yyStackPtr + 1;
	yyAttributeStack.put (Scanner.Attribute, yyStackPtr);
	yyTerminal := Scanner.GetToken;
	yyIsRepairing := FALSE;
      end;
    end;
  end; -- Parser

ErrorRecovery (
	Terminal   : INTEGER;
	StateStack : ARRAY [INTEGER];			-- yyStackType
	StackSize  : INTEGER;
	StackPtr   : INTEGER				-- LONGINT	
	) : INTEGER is
  require
    not StateStack.void;
  local
    TokensSkipped	: BOOLEAN;
    ContinueSet		: Sets;
    RestartSet		: Sets;
    local_token		: INTEGER;			-- new
    index		: INTEGER;
    ScanAttribute	: SCANATTRIBUTE;
  do

-- 1. report the error
    ScanAttribute ?= Scanner.Attribute;
    Errors.ErrorMessage (Errors.SyntaxError, Errors.Error, ScanAttribute.Line, ScanAttribute.Column);

-- 2. report the set of expected terminal symbols
    ContinueSet.Create (yyLastTerminal);
    ComputeContinuation (StateStack, StackSize, StackPtr, ContinueSet);
    from index := 0
    until index > yyLastTerminal loop
      if ContinueSet.IsElement (index) then
	Errors.ErrorMessageI (Errors.ExpectedTokens, Errors.Information,
	  ScanAttribute.Line, ScanAttribute.Column, Errors.IsString, xxTokenName (index));
      end; -- if
      index := index + 1;
    end; -- loop
    ContinueSet.Forget;

-- 3. compute the set of terminal symbols for restart of the parse
    RestartSet.Create (yyLastTerminal);
    ComputeRestartPoints (StateStack, StackSize, StackPtr, RestartSet);

-- 4. skip terminal symbols until a restart point is reached
    TokensSkipped := FALSE;

    from local_token := Terminal		-- evtl. Termial.clone
    until RestartSet.IsElement (local_token) loop
      local_token := Scanner.GetToken;
      TokensSkipped := TRUE;
    end; -- loop
    RESULT := local_token;
    RestartSet.Forget;

-- 5. report the restart point
    if TokensSkipped then
      ScanAttribute ?= Scanner.Attribute;
      Errors.ErrorMessage (Errors.RestartPoint, Errors.Information, ScanAttribute.Line, ScanAttribute.Column);
    end;
  end; -- ErrorRecovery


--   compute the set of terminal symbols that can be accepted (read)
--   in a given stack configuration (eventually after reduce actions)


ComputeContinuation (
	Stack       : ARRAY [INTEGER];			-- yyStackType
	StackSize   : INTEGER;
	StackPtr    : INTEGER;				-- LONGINT
	ContinueSet : Sets
	) is
  require
    not Stack.void;
    StackSize >= 0;
    StackPtr >= Stack.lower and StackPtr <= Stack.upper
  local
    Terminal	: INTEGER;				-- yySymbolRange;
  do
    ContinueSet.AssignEmpty;

    from Terminal := yyFirstTerminal
    until Terminal > yyLastTerminal loop
      if IsContinuation (Terminal, Stack, StackSize, StackPtr) then
        ContinueSet.Include (Terminal);
      end;
      Terminal := Terminal + 1;
    end; -- loop
end; -- ComputeContinuation


--   check whether a given terminal symbol can be accepted (read)
--   in a certain stack configuration (eventually after reduce actions)


IsContinuation (
	Terminal   : INTEGER;				-- yySymbolRange
	ParseStack : ARRAY [INTEGER];			-- yyStackType
	StackSize  : INTEGER;
	StackPtr   : INTEGER				-- LONGINT	
	) : BOOLEAN is
  require
    not ParseStack.void;
    StackSize >= 0;
    StackPtr >= ParseStack.lower and StackPtr <= ParseStack.upper
  local
    State		: INTEGER;			-- LONGINT;
    Nonterminal		: INTEGER;			-- yySymbolRange;
    Stack		: ARRAY [INTEGER];		-- yyStackType;
    local_StackPtr	: INTEGER;			-- new
    yyquit_loop1	,
    yyquit_loop2	: BOOLEAN;
  do
    Stack := ParseStack.duplicate;
    local_StackPtr := StackPtr;
    State := Stack.item (local_StackPtr);

    from until yyquit_loop1 loop -- loop1
      Stack.put (State, local_StackPtr);
      State := Next (State, Terminal);
      if State = yyNoState then
        Stack.Forget;
        RESULT := FALSE;
        yyquit_loop1 := TRUE;
      end;
      if not yyquit_loop1 and then State <= yyLastReadReduceState then -- read or read reduce ?
        Stack.Forget;
        RESULT := TRUE;
        yyquit_loop1 := TRUE;
      end;

      if not yyquit_loop1 then
        from yyquit_loop2 := FALSE
	until yyquit_loop2 or yyquit_loop1 loop -- loop2	-- reduce
          if State = yyStopState then
            Stack.Forget;
            RESULT := TRUE;
            yyquit_loop2 := TRUE;
            yyquit_loop1 := TRUE;
          else 
	    local_StackPtr := local_StackPtr - yyLength.item (State);
	    Nonterminal := yyLeftHandSide.item (State);
	  end;

          if not (yyquit_loop2 or yyquit_loop1) then
            State := Next (Stack.item (local_StackPtr), Nonterminal);
            if local_StackPtr >= StackSize then
              Stack.Forget;
            end;
            local_StackPtr := local_StackPtr + 1;
            if State < yyFirstReadReduceState then	-- read nonterminal ?
              yyquit_loop2 := TRUE;			-- EXIT
	    else
              State := yyFinalToProd.item (State);	-- read reduce
            end;
          end;
        end; -- loop2
      end;
    end;
  end; -- IsContinuation


--   compute a set of terminal symbols that can be used to restart
--   parsing in a given stack configuration. we simulate parsing until
--   end of file using a suffix program synthesized by the function
--   Continuation. All symbols acceptable in the states reached during
--   the simulation can be used to restart parsing.


ComputeRestartPoints (
	ParseStack : ARRAY [INTEGER];			-- yyStackType
	StackSize  : INTEGER;
	StackPtr   : INTEGER;				-- LONGINT
	RestartSet : Sets
	) is
  require
    not ParseStack.void;
    StackSize >= 0;
    StackPtr >= ParseStack.lower and StackPtr <= ParseStack.upper
  local
    Stack		: ARRAY [INTEGER];		-- yyStackType;
    State		: INTEGER;			-- LONGINT;
    Nonterminal		: INTEGER;			-- yySymbolRange;
    ContinueSet		: Sets;
    local_StackSize	,				-- new
    local_StackPtr	: INTEGER;
    yyquit_loop1	,
    yyquit_loop2	: BOOLEAN;
  do
    Stack := ParseStack.duplicate;
    local_StackSize := StackSize;
    local_StackPtr := StackPtr;
    ContinueSet.Create (yyLastTerminal);
    RestartSet.AssignEmpty;
    State := Stack.item (local_StackPtr);

    from until yyquit_loop1 loop -- loop 1
      if local_StackPtr >= local_StackSize then
        local_StackSize := 2 * local_StackSize;
        Stack.resize (0, local_StackSize);
      end;

      Stack.put (State, local_StackPtr);
      ComputeContinuation (Stack, local_StackSize, local_StackPtr, ContinueSet);
      RestartSet.Union (ContinueSet);
      State := Next (State, yyContinuation.item (State));

      if State >= yyFirstReadReduceState then		-- final state ?
        if State <= yyLastReadReduceState then		-- read reduce ?
          local_StackPtr := local_StackPtr + 1;
          State := yyFinalToProd.item (State);
        end;

        from yyquit_loop2 := FALSE
	until yyquit_loop1 or else yyquit_loop2 loop -- loop 2	-- reduce
          if State = yyStopState then
            Stack.Forget;
            ContinueSet.Forget;
            yyquit_loop1 := TRUE;
            yyquit_loop2 := TRUE;			 -- RETURN
          else 
            local_StackPtr := local_StackPtr - yyLength.item (State);
            Nonterminal := yyLeftHandSide.item (State);
          end;

          if not yyquit_loop1 then
            State := Next (Stack.item (local_StackPtr), Nonterminal);
            local_StackPtr := local_StackPtr + 1;
            if State < yyFirstReadReduceState then	-- read nonterminal ?
              yyquit_loop2 := TRUE;			-- EXIT
	    else
              State := yyFinalToProd.item (State);	-- read reduce
            end;
          end;
        end; -- loop 2
      else						-- read
        local_StackPtr := local_StackPtr + 1;
      end;
    end; -- loop 1
end; -- ComputeRestartPoints


-- access the parse table:   Next : State x Symbol -> State

Next (State: INTEGER; Symbol: INTEGER): INTEGER is
  local
    TCombIndex	: INTEGER;				-- yyTCombTypePtr;
    NCombIndex	: INTEGER;				-- yyNCombTypePtr;
    local_state	: INTEGER;				-- new
    yyquit	: BOOLEAN;
  do
    local_state := State;
    if Symbol <= yyLastTerminal then
      from until yyquit loop
        TCombIndex := yyTBase.item (local_state) + Symbol;
        if yyTComb.item (TCombIndex).CheckState /= local_state then
          local_state := yyDefault.item (local_state);
          if local_state = yyNoState then
            RESULT := yyNoState;
            yyquit := TRUE;
          end;
        else
          RESULT := yyTComb.item (TCombIndex).NextState;
          yyquit := TRUE;
        end;
      end; -- loop
    else
      NCombIndex := yyNBase.item (local_state) + Symbol;
      RESULT := yyNComb.item (NCombIndex);
    end;
end; -- Next

yyGetTables is
  require
    not yyTBase.void;
    not yyNBase.void;
    not yyDefault.void;
    not yyTComb.void;
    not yyNComb.void;
    not yyLength.void;
    not yyLeftHandSide.void;
    not yyContinuation.void;
    not yyFinalToProd.void
  local
    inputfile,
    storefile		: FILE;
    error,
    retrieved_data	: BOOLEAN;
    retry_counter	: INTEGER
  do
    storefile.Create (yyParserEiffelObjectFile);	-- eiffel object file
    inputfile.Create (yyParserEiffelTextFile);		-- ascii representation

      if not error and  check_consistency(inputfile, storefile)
        and then Retrieve_stored_Data (storefile) then	-- all fine
        retrieved_data := TRUE;				-- no need to save it later
      elsif Read_ascii_Data (inputfile) then		-- all fine
      else						-- wrong parser tables
        Errors.ErrorMessage (Errors.WrongParseTable, Errors.Fatal, 0, 0);
      end;

      if not retrieved_data then			-- now store tables
	storefile.open_write;
	yyTBase.store_by_file (storefile);
	yyNBase.store_by_file (storefile);
	yyDefault.store_by_file (storefile);
	yyTComb.store_by_file (storefile);
	yyNComb.store_by_file (storefile);
	yyLength.store_by_file (storefile);
	yyLeftHandSide.store_by_file (storefile);
	yyContinuation.store_by_file (storefile);
	yyFinalToProd.store_by_file (storefile);
	storefile.Close;
     end;

  rescue
    retry_counter := retry_counter + 1;
    if retry_counter = 2 then				-- tables unuseable
      Errors.ErrorMessage (Errors.WrongParseTable, Errors.Fatal, 0, 0);
    end;
    if exception = Sigsegv then
      error := TRUE;				-- retry to read only the ASCII tables
      io.error.new_line;
      io.error.putstring ("exception, fileerror: ");
      io.error.putint (exception);
      io.error.putchar (' ');
      io.error.putint (storefile.error);
      io.error.new_line;
      io.error.putstring (yyParserEiffelObjectFile);
      io.error.putstring (" maybe corrupt, now trying ");
      io.error.putstring (yyParserEiffelTextFile);
      io.error.new_line;
      
      retry;
    end; -- if
				
  end; -- GetTables

check_consistency (older, newer: FILE): BOOLEAN is
  do
    if older.exists and newer.exists then
      if older.date > newer.date then
$@         io.error.putstring("@ warning: ");
        io.error.putstring(yyParserEiffelTextFile);
        io.error.putstring(" is newer than ");
        io.error.putstring(yyParserEiffelObjectFile);
        io.error.new_line;
        RESULT := FALSE;
      else
        RESULT := TRUE;
      end;
    end;
  end; -- check_consistency

Retrieve_stored_Data (storefile: FILE): BOOLEAN is
  require
    not storefile.void
  local
    error : BOOLEAN;
  do
    if storefile.exists and then storefile.readable then
      storefile.open_read;
      if storefile.is_open_read then
        yyTBase.retrieve_by_file (storefile);
        error := error or yyTBase.retrieved.void;
        yyTBase := yyTBase.retrieved;

        yyNBase.retrieve_by_file (storefile);
        error := error or yyNBase.retrieved.void;
        yyNBase := yyNBase.retrieved;

        yyDefault.retrieve_by_file (storefile);
        error := error or yyDefault.retrieved.void;
        yyDefault := yyDefault.retrieved;

        yyTComb.retrieve_by_file (storefile);
        error := error or yyTComb.retrieved.void;
        yyTComb := yyTComb.retrieved;

        yyNComb.retrieve_by_file (storefile);
        error := error or yyNComb.retrieved.void;
        yyNComb := yyNComb.retrieved;

        yyLength.retrieve_by_file (storefile);
        error := error or yyLength.retrieved.void;
        yyLength := yyLength.retrieved;

        yyLeftHandSide.retrieve_by_file (storefile);
        error := error or yyLeftHandSide.retrieved.void;
        yyLeftHandSide := yyLeftHandSide.retrieved;

        yyContinuation.retrieve_by_file (storefile);
        error := error or yyContinuation.retrieved.void;
        yyContinuation := yyContinuation.retrieved;

        yyFinalToProd.retrieve_by_file (storefile);
        error := error or yyFinalToProd.retrieved.void;
        yyFinalToProd := yyFinalToProd.retrieved;

        storefile.Close;
      else
        Errors.ErrorMessage (Errors.ReadParseTable, Errors.Fatal, 0, 0);
      end;
      Result := not error;
    else
      Result := FALSE;
    end; -- if

  end; -- Retrieve_stored_Data

Read_ascii_Data (inputfile: FILE): BOOLEAN is
  require
    not inputfile.void
  do
    if inputfile.exists and then inputfile.readable then
        inputfile.open_read;

        yyTBase        := GetTable1 (inputfile, yyLastReadState, 0);
        yyNBase        := GetTable1 (inputfile, yyLastReadState, 0);
        yyDefault      := GetTable1 (inputfile, yyLastReadState, 0);

        yyTComb        := GetTable2 (inputfile, yyTableMax, 0);
        yyNComb        := GetTable1 (inputfile, yyNTableMax - yyLastTerminal - 1, yyLastTerminal + 1);

        yyLength       := GetTable1 (inputfile, yyLastReduceState - yyFirstReduceState, yyFirstReduceState);
        yyLeftHandSide := GetTable1 (inputfile, yyLastReduceState - yyFirstReduceState, yyFirstReduceState);
        yyContinuation := GetTable1 (inputfile, yyLastReadState, 0);
        yyFinalToProd  := GetTable1 (inputfile, yyLastReadReduceState - yyFirstReadReduceState, yyFirstReadReduceState);

        inputfile.Close;

        Result :=  not (yyTBase.void       or yyNBase.void 
                   or  yyDefault.void      or yyTComb.void
                   or  yyNComb.void        or yyLength.void
                   or  yyLeftHandSide.void or yyContinuation.void
                   or  yyFinalToProd.void);
    else
      Result := FALSE;
    end; -- if
  end; -- Read_ascii_Data

GetTable1 (inputfile: FILE; no_of_elements, offset: INTEGER): LSARRAY [INTEGER] is
  require
    not inputfile.void
  local
    tablesize	: INTEGER;
    inputerror	: INTEGER;
    tableindex	: INTEGER;
  do
    inputfile.readint;
    tablesize := inputfile.lastint;
    inputerror := inputfile.error;
    if tablesize = no_of_elements + 1 then
      inputfile.next_line;				-- ignore rest of line
      if inputerror /= 0 then				-- errorhandling done 
        Result.Forget;					-- error, no data
      else
        Result.Create (offset, offset + tablesize - 1);
        from tableindex := offset
        until inputfile.error /= 0 or tablesize + offset = tableindex loop
          inputfile.readint;
          Result.put (inputfile.lastint, tableindex);
          tableindex := tableindex + 1;
        end; -- loop
        if inputfile.error /= 0 then
          Result.Forget;				-- error, no data
        end;
      end; -- if
    else						-- table mismatch
      Errors.ErrorMessage (Errors.WrongParseTable, Errors.Fatal, 0, 0);
    end;
  end; -- GetTable1

GetTable2 (inputfile: FILE; no_of_elements, offset: INTEGER): LSARRAY [StateControl] is
  require
    not inputfile.void
  local
    tablesize	: INTEGER;
    inputerror	: INTEGER;
    tableindex	: INTEGER;
    x		: StateControl;
  do
    inputfile.readint;
    tablesize := inputfile.lastint;
    tablesize := tablesize div 2;			-- 2 entries per index
    if tablesize = no_of_elements + 1 then
      inputerror := inputfile.error;
      inputfile.next_line;				-- ignore rest of line
      if inputerror /= 0 then				-- errorhandling done 
        Result.Forget;					-- error, no data
      else
        Result.Create (offset, offset + tablesize - 1);
        from tableindex := offset
        until inputfile.error /= 0 or tablesize + offset = tableindex loop
          x.Create;
          inputfile.readint;
          x.setcheck (inputfile.lastint);
          inputfile.readint;
          x.setnext (inputfile.lastint);
          Result.put (x, tableindex);
          tableindex := tableindex + 1;
        end; -- loop
        if inputfile.error /= 0 then
          Result.Forget;				-- error, no data
        end;
      end; -- if
    else						-- table mismatch
      Errors.ErrorMessage (Errors.WrongParseTable, Errors.Fatal, 0, 0);
    end;
  end; -- GetTable2
 
yyErrorCheck (ErrorCode: INTEGER; Info: INTEGER) is
  do
    if Info < 0 then
      Errors.ErrorMessageI (ErrorCode, Errors.Fatal, 0, 0, Errors.IsInteger, Info);
    end;
  end; -- yyErrorCheck

BeginParser is
  do
$B	-- BEGIN section is inserted here
    if not yyIsInitialized then
      yyIsInitialized := TRUE;
      yyGetTables;
    end;
  end; -- BeginParser

CloseParser is
  do
$C	-- CLOSE section is inserted here
  end; -- CloseParser

$@ end; -- @
