--|-----------------------------------------------------------------
--|-- G"unther K"ogel
--|-- University of Stuttgart
--|-----------------------------------------------------------------
-- scanner body used by rex

indexing
	date: "Mon Feb  1 18:00:26 MET 1993";
	revision: "1.7"

-- 1.7 time consistency check between yyScannerEiffelTextFile and
--     yyScannerEiffelObjectFile
-- 1.6 debug output depends now on yydebugScanner
-- 1.5 fixed bug in yyDNoState 
-- 1.4 add more assertions and change GetTable1 and GetTable2
-- 1.3 add assertions, some make up
-- 1.2 modify data tables and start up 18.05.92
-- 1.1 modify loop constructs 14.05.92
-- 1.0 adapt some functions and procedures to eiffel 22.04.92

$@ class @
export
$X
inherit exceptions
	rename comment as exceptions_comment

feature

yyo		: FILE;			-- outputfile during debug
yydebugScanner	: BOOLEAN;		-- if true scanner debug information is printed

Create is
					-- initialization of scanner data and then
					-- initialization of user data
  do
    debug
      if yydebugScanner then
        yyo:= io.error;			-- debug prints to std_error
      end;
    end;

    yyScanAttribute.Create;
    yyEobTrans.Create (0, -1);		-- will be created or loaded later
$M    yyAction.Create (0, -1);		-- will be created or loaded later
    yyStateStack.Create (0, yyTokenLngMax);
    yyStateStack.put (yyDNoState, 0);
    yyFileStack.Create (yyMAXInputNesting);		-- maximum nesting depth
    yySourceFile.Create;
    yyStartState := 1;
    yyChBufferPtr.Create (3);				-- create here share later
    yyScannerEiffelTextFile.Create (32);
$@     yyScannerEiffelTextFile.append ("@.txt");	-- default name
    yyScannerEiffelObjectFile.Create (32);
$@     yyScannerEiffelObjectFile.append ("@.eof");	-- default name
    Do_tricky_auto_init;

					-- user data initialisation
$I
  end; -- Create

Do_tricky_auto_init is
					-- create special data constellation for init
					-- first automaton state has to be yyDNoState!
  local
    help_1	: StateControl;
  do
    yyChBufferIndex	:= 2;		-- index of first character in buffer
    yyStartState	:= 1;		-- is copied into yyState during start

    yyChBufferPtr.fill_blank;
    yyChBufferPtr.put ('\1', 1);
    yyChBufferPtr.put ('\1', 2);

    yyScanBase.Create (0, 1);		-- only item (1) is needed 
    yyScanBase.put (-1, 1);		-- to get yyIndex equal to 0
	-- with this data presetted we get yyIndex to 0
	-- next the automaton is presetted, that yyState will get the value yyDNoState!

	--  if yyComb.item (yyIndex).CheckState /= yyState then
	--    yyState := yyDefault.item (yyState);
	--  else
	--    ...

    yyComb.Create (0, 0);		-- only item (1) is needed
      help_1.Create;
      help_1.SetCheck (-1);		-- value other then yyState necessary
      help_1.SetNext (-1);		-- value not important
    yyComb.put (help_1, 0);		-- enter item

    yyDefault.Create (0, 1);		-- only item (1) is needed
    yyDefault.put (yyDNoState, 1);	-- state for auto init
  end; -- Do_tricky_auto_init

$G global user declarations
 
-- CONST
  yyDNoState		: INTEGER IS 0;
  yyFileStackSize	: INTEGER IS 16;
  yyTokenLngMax		: INTEGER IS 256;
  yyChBufferSize	: INTEGER IS 2048;
  yyMAXInputNesting	: INTEGER is 15;
  yyScannerEiffelTextFile	: STRING;
  yyScannerEiffelObjectFile	: STRING;

$C constant declarations
 
-- VAR
  yyScanAttribute	: SCANATTRIBUTE;
  Attribute		: ATTRIBUTE;
  TokenLength		: INTEGER;
  yyScanBase		: LSARRAY [INTEGER];
  yyDefault		: LSARRAY [INTEGER];	-- [0..yyDStateCount] OF 0..yyDStateCount 
  yyComb		: LSARRAY [StateControl]; -- [0..yyTableSize]
  yyEobTrans		: LSARRAY [INTEGER];	-- [0..yyDStateCount] OF 0..yyDStateCount;
  yyAction		: LSARRAY [INTEGER];	-- yyStateRange	OF yyTableElmt;
  yyStateStack		: ARRAY [INTEGER];	-- [0..yyTokenLngMax] OF 0..yyDStateCount;
$@   yySourceFile		: $source;
$@   yyFileStack		: FIXED_STACK [$source];
  yyStartState		: INTEGER;		-- 0..yyDStateCount yyStateRange;
  yyPreviousStart	: INTEGER;		-- 0..yyDStateCount yyStateRange;
  yyCh			: CHARACTER;
  yyChBufferPtr		: STRING;		-- yyChBufferType;
  yyChBufferIndex	: INTEGER;		-- 0..yyChBufferPtr.upper;
  yyBytesRead		: INTEGER;		-- SHORTINT;
  yyEof			: BOOLEAN;
  yyLineCount		: INTEGER;		-- CARDINAL;
  yyLineStart		: INTEGER;		-- 0..yyChBufferPtr.upper;

  yyStdInput		: STRING;		-- new helpful variables


GetToken: INTEGER is
					-- consumes characters and produces tokens
					-- to leave call `Return (Code)'
  local
    yyState	: INTEGER;		-- yyStateRange;
    yyIndex	: INTEGER;
    yyRestart	,
    yyfinish_L1	,			-- new control variables for loop construct 
    yyfinish_L4	: BOOLEAN;

$L local user declarations
  do
    from Result := -1
    until Result >= 0 loop -- LOOP1
      if not yyRestart then		-- eventually restart after sentinel
	yyState		:= yyStartState;
	TokenLength 	:= 0;
$J      if yyChBufferPtr.item (yyChBufferIndex - 1) = yyEolCh then yyState := yyState + 1; end;
      else
        yyRestart	:= FALSE;
      end;
 
	-- ASSERT yyChBuffer [yyChBufferIndex] = first character
 
      from until yyState = yyDNoState loop -- LOOP3
	debug				-- execute as many state transitions as possible
	  if yydebugScanner then
	    yyo.putchar ('<');
	    yyo.putint (yyState);
	    yyo.putchar ('>');
	  end;
	end;
							-- determine next state
        yyIndex := yyScanBase.item (yyState) + yyChBufferPtr.item_code (yyChBufferIndex);
	if yyComb.item (yyIndex).CheckState /= yyState then
	  yyState := yyDefault.item (yyState);
	else
	  yyState := yyComb.item (yyIndex).NextState;
	  TokenLength := TokenLength + 1;
	  yyStateStack.put (yyState, TokenLength);	-- push state 
	  yyChBufferIndex := yyChBufferIndex + 1;	-- get next character
	end; -- if
      end; -- LOOP3

      Attribute := yyScanAttribute;
      from yyfinish_L4 := FALSE				-- search for last final state
      until yyfinish_L4 loop -- LOOP4
	debug
	  if yydebugScanner then
	    yyo.putint (TokenLength); yyo.putchar (' ');
	    yyo.putint (yyStateStack.item (TokenLength));
	    yyo.putchar ('\n');
	  end;
	end;

$A case header and user actions		-- inspect yyStateStack.item (TokenLength)
$N non final states
							-- non final states
	  yyChBufferIndex := yyChBufferIndex - 1;	-- return character
	  TokenLength := TokenLength - 1;		-- pop state

$P      when yyDefaultState then 
	  yyScanAttribute.SetPosition (yyLineCount, yyChBufferIndex - yyLineStart);
	  yyChBufferIndex := yyChBufferIndex + 1;
	  TokenLength := 1;
$D default action
	  yyfinish_L4 := TRUE;				-- EXIT

	when yyDNoState then				-- automatic initialization 
	  debug
	    if yydebugScanner then
	      yyo.putstring ("enter yyDNoState\n");
	    end;
	  end;
	  yyGetTables;
	  yyStateStack.put (yyDefaultState, 0);
	  if yyFileStack.empty then
	    yyInitialize;
	    if not yySourceFile.Open (yyStdInput) then
	      HALT (-1);				-- can not open input
	    end;
	  end;
	  yyfinish_L4 := TRUE;				-- EXIT

$O	when yyEobState then				-- end of buffer sentinel found
	  yyChBufferIndex := yyChBufferIndex - 1;	-- undo last state transition
	  TokenLength := TokenLength - 1;		-- get previous state
	  if TokenLength = 0 then
	    yyState := yyStartState;
$J	      if yyChBufferPtr.item (yyChBufferIndex - 1) = yyEolCh then yyState := yyState + 1; end;
	  else
	    yyState := yyStateStack.item (TokenLength);
	  end;

	  if yyChBufferIndex /= yyBytesRead + yyTokenLngMax + 1 then
	    yyState := yyEobTrans.item (yyState);	-- end of buffer sentinel in buffer
	    if yyState /= yyDNoState then
	      yyChBufferIndex := yyChBufferIndex + 1;
	      TokenLength := TokenLength + 1;
	      yyStateStack.put (yyState, TokenLength);
	      yyRestart := TRUE; yyfinish_L4 := TRUE;	-- EXIT
	    end;
	  else						-- end of buffer reached

				-- copy initial part of token in front of input buffer

	    from yyIndex := -TokenLength
	    until yyIndex >= -1 loop
	      yyChBufferPtr.put (yyChBufferPtr.item (yyChBufferIndex + yyIndex), yyTokenLngMax + 1 + yyIndex);
	      yyIndex := yyIndex + 1;
	    end;

	    if not yyEof then				-- read buffer and restart
	      yyLineStart := yyLineStart - yyBytesRead;
	      yyChBufferIndex := yyTokenLngMax + 1;
	      yyChBufferPtr.put ('\0', yyChBufferIndex);
	      yyBytesRead := yySourceFile.Read (yyChBufferSize);
	      if yyBytesRead <= 0 then
		yyBytesRead := 0;
		yyEof := TRUE;
	      end;
	      yyChBufferPtr.share (yySourceFile.buffer);
	      yyChBufferPtr.extend (yyEobCh);
	      yyChBufferPtr.extend (' ');
	      yyRestart := TRUE; yyfinish_L4 := TRUE;	-- EXIT
	    else
	      if TokenLength = 0 then			-- end of file reached
		yyScanAttribute.SetPosition (yyLineCount, yyChBufferIndex - yyLineStart);
		CloseFile;
		if yyFileStack.empty then
$E eof action
		end;
		if yyFileStack.empty then Result := 0; end;
		yyfinish_L4 := TRUE;			-- EXIT
	      end;
	    end;
	  end;
	else						-- belongs to inspect
	  if TokenLength >= yyTokenLngMax then
	    yyErrorMessage (1);
	  else
	    yyErrorMessage (0);
	  end;
	end; -- inspect
      end; -- LOOP4
    end; -- LOOP1
  end; -- GetToken
 
BeginFile (FileName: STRING): BOOLEAN is
				-- begin new file, current position in file will be saved
  do
    if yyStateStack.item (0) = yyDNoState then		-- have tables been read in ?
      yyGetTables;
      yyStateStack.put (yyDefaultState, 0);		-- stack underflow sentinel
    end;
    yyInitialize;
    Result := yySourceFile.Open (FileName);
  end; -- BeginFile

yyInitialize is
  do
    if yyFileStack.full then
      yyErrorMessage (3);
    else
      yyFileStack.put (yySourceFile);
      yySourceFile.Create;
      yyFileStack.item.SetChBufferIndex (yyChBufferIndex);
      yyFileStack.item.SetBytesRead (yyBytesRead);
      yyFileStack.item.SetEof (yyEof);
      yyFileStack.item.SetLineCount (yyLineCount);
      yyFileStack.item.SetLineStart (yyLineStart);
							-- initialize file state
      yyChBufferPtr.share (yySourceFile.buffer);
      yyChBufferPtr.fill_blank;
      yyChBufferPtr.put (yyEolCh, yyTokenLngMax);	-- begin of line indicator
      yyChBufferPtr.put (yyEobCh, yyTokenLngMax + 1);	-- end of buffer sentinel
      yyChBufferPtr.put (' '    , yyTokenLngMax + 2);	-- mark end of buffer

      yyChBufferIndex	:= yyTokenLngMax + 1;
      yyBytesRead	:= 0;
      yyEof		:= FALSE;
      yyLineCount	:= 1;
      yyLineStart	:= yyTokenLngMax + yyBytesRead;
    end; -- if
  end; -- yyInitialize;

CloseFile is
			-- counterpart to BeginFile, return to file processed before
  do
    if yyFileStack.empty then
      yyErrorMessage (4);
    else
      yySourceFile.Close;
      yySourceFile.Forget;
      yySourceFile	:= yyFileStack.item;		-- restore previous file
      yyFileStack.remove;
      yyChBufferPtr.share (yySourceFile.Buffer);	-- restore previous control data
      yyChBufferIndex	:= yySourceFile.ChBufferIndex;
      yyBytesRead	:= yySourceFile.BytesRead;
      yyEof		:= yySourceFile.Eof;
      yyLineCount	:= yySourceFile.LineCount;
      yyLineStart	:= yySourceFile.LineStart;
    end; -- if
  end; -- CloseFile

GetWord: STRING is
						-- character representation of token
  require
    yyChBufferPtr_is_void: not yyChBufferPtr.void
  do
    Result := yyChBufferPtr.substring (yyChBufferIndex - TokenLength, yyChBufferIndex - 1);
  end; -- GetWord;
 
yyStart (State: INTEGER) is
  do
    yyPreviousStart	:= yyStartState;
    yyStartState	:= State;
  end; -- yyStart
 
yyPrevious is
  local
    s	: INTEGER;
  do
    s			:= yyStartState;
    yyStartState	:= yyPreviousStart;
    yyPreviousStart	:= s;
  end; -- yyPrevious
 
yyEcho is
  local
    Word	: STRING;
  do
    Word := GetWord;
    io.output.putstring (Word);
  end; -- yyEcho
 
yyLess (n: INTEGER) is
  require
     yyLess_n_greater_zero: n > 0
   do
     yyChBufferIndex := yyChBufferIndex - (TokenLength - n);
     TokenLength := n;
   end; -- yyLess
 
yyTab is
  do
    yyLineStart := yyLineStart - (7 - (yyChBufferIndex - yyLineStart - 2) mod 8);
  end; -- yyTab

yyTab1 (a: INTEGER) is
  do
    yyLineStart := yyLineStart - (7 - (yyChBufferIndex - yyLineStart - TokenLength + a - 1) mod 8);
  end; -- yyTab1

yyTab2 (a, b: INTEGER) is
  do
    yyLineStart := yyLineStart - (7 - (yyChBufferIndex - yyLineStart - TokenLength + a - 1) mod 8);
  end; -- yyTab2

yyEol (Column: INTEGER) is
  require
    yyEol_Column_greater_or_equal_zero: Column >= 0
  do
    yyLineCount := yyLineCount + 1;
    yyLineStart := yyChBufferIndex - 1 - Column;
  end; -- yyEol

output (c: CHARACTER) is
  do
    io.output.putchar (c);
  end; -- output

unput (c: CHARACTER) is
  require
    unput_error: yyChBufferIndex > 0 and not yyChBufferPtr.void
  do
    yyChBufferIndex := yyChBufferIndex - 1;
    yyChBufferPtr.put (c, yyChBufferIndex);
  end; -- unput

input: CHAR is
  require
    input_error: not yySourceFile.void and not yyChBufferPtr.void
  do
    if yyChBufferIndex = yyBytesRead + yyTokenLngMax + 1 then
      if not yyEof then
        yyLineStart := yyLineStart - yyBytesRead;
        yyChBufferIndex := yyTokenLngMax + 1;
	yyBytesRead := yySourceFile.Read (yyChBufferSize - 2);
        if yyBytesRead <= 0 then
          yyBytesRead := 0;
          yyEof := TRUE;
        end;
        yyChBufferPtr.extend (yyEobCh);
      end;
    end;
    if yyChBufferIndex = yyBytesRead + yyTokenLngMax + 1 then
      Result := '\0';
    else
      yyChBufferIndex := yyChBufferIndex + 1;
      Result := yyChBufferPtr.item (yyChBufferIndex - 1);
    end;
  end; -- input
 
CloseScanner is
					-- contains user finalization code if any
  do
$F user finalization code
  end; -- CloseScanner
 
yyGetTables is
  require
    not yyScanBase.void;
    not yyDefault.void;
    not yyEobTrans.void;
$M    not yyAction.void;
    not yyComb.void
  local
    inputfile,
    storefile		: FILE;
    error,
    retrieved_data	: BOOLEAN;
    retry_counter	: INTEGER;
  do
    storefile.Create (yyScannerEiffelObjectFile);	-- eiffel object file
    inputfile.Create (yyScannerEiffelTextFile);		-- ascii representation

    if not error and then check_consistency (inputfile, storefile)
       and then Retrieve_stored_Data (storefile) then
							-- all fine
      retrieved_data := TRUE;				-- no need to save it later
    elsif Read_ascii_Data (inputfile) then		-- all fine
    else
      yyErrorMessage (2);				-- wrong scanner tables
    end;
							-- now store tables
    if not retrieved_data then
      storefile.open_write;
      yyScanBase.store_by_file (storefile);
      yyDefault.store_by_file (storefile);
      yyEobTrans.store_by_file (storefile);
$M      yyAction.store_by_file (storefile);
      yyComb.store_by_file (storefile);
      storefile.Close;
    end;

  rescue
    retry_counter := retry_counter + 1;
    if retry_counter = 2 then yyErrorMessage (2); end;	-- tables unuseable
    if exception = Sigsegv then
      error := TRUE;				-- retry to read only the ASCII tables
      io.error.new_line;
      io.error.putstring ("exception, fileerror: ");
      io.error.putint (exception);
      io.error.putchar (' ');
      io.error.putint (storefile.error);
      io.error.new_line;
      io.error.putstring (yyScannerEiffelObjectFile);
      io.error.putstring (" maybe corrupt, now trying ");
      io.error.putstring (yyScannerEiffelTextFile);
      io.error.new_line;
      retry;
    end; -- if
  end; -- GetTables

check_consistency (older, newer: FILE): BOOLEAN is
  do
    if older.exists and newer.exists then
      if older.date > newer.date then
$@         io.error.putstring ("@ warning: ");
	io.error.putstring (yyScannerEiffelTextFile);
	io.error.putstring (" is newer than ");
	io.error.putstring (yyScannerEiffelObjectFile);
	io.error.new_line;
	result := FALSE;
      else
	result := TRUE;
      end;
    end;
  end; -- check_consistency

Retrieve_stored_Data (storefile: FILE): BOOLEAN is
  require
    not storefile.void
  local
    error: BOOLEAN;
  do
    if storefile.exists and then storefile.readable then
      storefile.open_read;

      yyScanBase.retrieve_by_file (storefile);
      error := yyScanBase.retrieved.void;
      yyScanBase := yyScanBase.retrieved;

      yyDefault.retrieve_by_file (storefile);
      error := error or yyDefault.retrieved.void;
      yyDefault := yyDefault.retrieved;

      yyEobTrans.retrieve_by_file (storefile);
      error := error or yyEobTrans.retrieved.void;
      yyEobTrans := yyEobTrans.retrieved;

$M      yyAction.retrieve_by_file (storefile);
$M      error := error or yyAction.retrieved.void;
$M      yyAction := yyAction.retrieved;

      yyComb.retrieve_by_file (storefile);
      error := error or yyComb.retrieved.void;
      yyComb := yyComb.retrieved;
      storefile.Close;
      Result := not error;
    else
      Result := FALSE;
    end; -- if
  end; -- Retrieve_stored_Data

Read_ascii_Data (inputfile: FILE): BOOLEAN is
  require
    not inputfile.void
  do
    if inputfile.exists and then inputfile.readable then
      inputfile.open_read;
      yyScanBase := GetTable1 (inputfile, yyDStateCount, 0);
      yyDefault := GetTable1 (inputfile, yyDStateCount, 0);
      yyEobTrans := GetTable1 (inputfile, yyDStateCount, 0);

$M      yyAction := GetTable1 (inputfile, yyDStateCount, 0);
      yyComb := GetTable2 (inputfile, yyTablesize, 0);
      inputfile.Close;
      Result :=  not (yyScanBase.void or yyDefault.void or yyEobTrans.void or yyComb.void);
    else
      Result := FALSE;
    end; -- if
  end; -- Read_ascii_Data

GetTable1 (inputfile: FILE; no_of_elements, offset: INTEGER): lsarray [INTEGER] is
  require
    not inputfile.void
  local
    tablesize	: INTEGER;
    inputerror	: INTEGER;
    tableindex	: INTEGER;
  do
    inputfile.readint;
    tablesize := inputfile.lastint;
    inputerror := inputfile.error;
    if tablesize = no_of_elements + 1 then
      inputfile.next_line;				-- ignore rest of line
      if inputerror /= 0 then				-- errorhandling done 
        Result.Forget;					-- error, no data
      else
        Result.Create (offset, offset + tablesize - 1);
        from tableindex := offset
        until inputfile.error /= 0 or tablesize + offset = tableindex loop
          inputfile.readint;
          Result.put (inputfile.lastint, tableindex);
          tableindex := tableindex + 1;
        end; -- loop
        if inputfile.error /= 0 then
          Result.Forget;				-- error, no data
        end;
      end; -- if
    else
      yyErrorMessage (2);				-- table mismatch
    end;
  end; -- GetTable1

GetTable2 (inputfile: FILE; no_of_elements, offset: INTEGER): lsarray [StateControl] is
  require
    not inputfile.void
  local
    tablesize	: INTEGER;
    inputerror	: INTEGER;
    tableindex	: INTEGER;
    x		: StateControl;
  do
    inputfile.readint;
    tablesize := inputfile.lastint;
    tablesize := tablesize div 2;			-- 2 entries per index
    if tablesize = no_of_elements + 1 then
      inputerror := inputfile.error;
      inputfile.next_line;				-- ignore rest of line
      if inputerror /= 0 then				-- errorhandling done 
        Result.Forget;					-- error, no data
      else
        Result.Create (offset, offset + tablesize - 1);
        from tableindex := 0
        until inputfile.error /= 0 or tablesize + offset = tableindex loop
          x.Create;
          inputfile.readint;
          x.setcheck (inputfile.lastint);
          inputfile.readint;
          x.setnext (inputfile.lastint);
          Result.put (x, tableindex);
          tableindex := tableindex + 1;
        end; -- loop
        if inputfile.error /= 0 then
          Result.Forget;				-- error, no data
        end;
      end; -- if
    else
      yyErrorMessage (2);				-- table mismatch
    end;
  end; -- GetTable2
 
yyErrorMessage (ErrorCode: INTEGER) is
  do
    io.output.putint (yyScanAttribute.Line);
    io.output.putstring (", ");
    io.output.putint (yyScanAttribute.Column);
    inspect ErrorCode
$@       when 0 then io.error.putstring (": @: internal error");
$@       when 1 then io.error.putstring (": @: token too long");
$@       when 2 then io.error.putstring (": @: table mismatch");
$@       when 3 then io.error.putstring (": @: too many nested include files");
$@       when 4 then io.error.putstring (": @: file stack underflow (too many calls of CloseFile)");
    end;
    io.error.new_line; 
    HALT (-1 -ErrorCode);				-- no return from HALT!
  end; -- yyErrorMessage

HALT (exitcode: INTEGER) is
  external
    exit language "C"
  do
    exit (exitcode);
  end;

end -- scanner
